const peggyParser$1 = (
  // Generated by Peggy 3.0.2.
  //
  // https://peggyjs.org/
  // @ts-ignore
  function() {
    function peg$subclass(child, parent) {
      function C() {
        this.constructor = child;
      }
      C.prototype = parent.prototype;
      child.prototype = new C();
    }
    function peg$SyntaxError(message, expected, found, location) {
      var self = Error.call(this, message);
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(self, peg$SyntaxError.prototype);
      }
      self.expected = expected;
      self.found = found;
      self.location = location;
      self.name = "SyntaxError";
      return self;
    }
    peg$subclass(peg$SyntaxError, Error);
    function peg$padEnd(str, targetLength, padString) {
      padString = padString || " ";
      if (str.length > targetLength) {
        return str;
      }
      targetLength -= str.length;
      padString += padString.repeat(targetLength);
      return str + padString.slice(0, targetLength);
    }
    peg$SyntaxError.prototype.format = function(sources) {
      var str = "Error: " + this.message;
      if (this.location) {
        var src = null;
        var k;
        for (k = 0; k < sources.length; k++) {
          if (sources[k].source === this.location.source) {
            src = sources[k].text.split(/\r\n|\n|\r/g);
            break;
          }
        }
        var s = this.location.start;
        var offset_s = this.location.source && typeof this.location.source.offset === "function" ? this.location.source.offset(s) : s;
        var loc = this.location.source + ":" + offset_s.line + ":" + offset_s.column;
        if (src) {
          var e = this.location.end;
          var filler = peg$padEnd("", offset_s.line.toString().length, " ");
          var line = src[s.line - 1];
          var last = s.line === e.line ? e.column : line.length + 1;
          var hatLen = last - s.column || 1;
          str += "\n --> " + loc + "\n" + filler + " |\n" + offset_s.line + " | " + line + "\n" + filler + " | " + peg$padEnd("", s.column - 1, " ") + peg$padEnd("", hatLen, "^");
        } else {
          str += "\n at " + loc;
        }
      }
      return str;
    };
    peg$SyntaxError.buildMessage = function(expected, found) {
      var DESCRIBE_EXPECTATION_FNS = {
        // @ts-ignore
        literal: function(expectation) {
          return '"' + literalEscape(expectation.text) + '"';
        },
        // @ts-ignore
        class: function(expectation) {
          var escapedParts = expectation.parts.map(function(part) {
            return Array.isArray(part) ? classEscape(part[0]) + "-" + classEscape(part[1]) : classEscape(part);
          });
          return "[" + (expectation.inverted ? "^" : "") + escapedParts.join("") + "]";
        },
        // @ts-ignore
        any: function() {
          return "any character";
        },
        // @ts-ignore
        end: function() {
          return "end of input";
        },
        // @ts-ignore
        other: function(expectation) {
          return expectation.description;
        }
      };
      function hex(ch) {
        return ch.charCodeAt(0).toString(16).toUpperCase();
      }
      function literalEscape(s) {
        return s.replace(/\\/g, "\\\\").replace(/"/g, '\\"').replace(/\0/g, "\\0").replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r").replace(/[\x00-\x0F]/g, function(ch) {
          return "\\x0" + hex(ch);
        }).replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) {
          return "\\x" + hex(ch);
        });
      }
      function classEscape(s) {
        return s.replace(/\\/g, "\\\\").replace(/\]/g, "\\]").replace(/\^/g, "\\^").replace(/-/g, "\\-").replace(/\0/g, "\\0").replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r").replace(/[\x00-\x0F]/g, function(ch) {
          return "\\x0" + hex(ch);
        }).replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) {
          return "\\x" + hex(ch);
        });
      }
      function describeExpectation(expectation) {
        return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
      }
      function describeExpected(expected2) {
        var descriptions = expected2.map(describeExpectation);
        var i, j;
        descriptions.sort();
        if (descriptions.length > 0) {
          for (i = 1, j = 1; i < descriptions.length; i++) {
            if (descriptions[i - 1] !== descriptions[i]) {
              descriptions[j] = descriptions[i];
              j++;
            }
          }
          descriptions.length = j;
        }
        switch (descriptions.length) {
          // @ts-ignore
          case 1:
            return descriptions[0];
          // @ts-ignore
          case 2:
            return descriptions[0] + " or " + descriptions[1];
          // @ts-ignore
          default:
            return descriptions.slice(0, -1).join(", ") + ", or " + descriptions[descriptions.length - 1];
        }
      }
      function describeFound(found2) {
        return found2 ? '"' + literalEscape(found2) + '"' : "end of input";
      }
      return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
    };
    function peg$parse(input, options) {
      options = options !== void 0 ? options : {};
      var peg$FAILED = {};
      var peg$source = options.grammarSource;
      var peg$startRuleFunctions = { Filter: peg$parseFilter };
      var peg$startRuleFunction = peg$parseFilter;
      var peg$c0 = ",";
      var peg$c1 = "(";
      var peg$c2 = ")";
      var peg$c3 = "in";
      var peg$c4 = "eq";
      var peg$c5 = "ne";
      var peg$c6 = "gt";
      var peg$c7 = "ge";
      var peg$c8 = "lt";
      var peg$c9 = "le";
      var peg$c10 = "and";
      var peg$c11 = "or";
      var peg$c12 = "[";
      var peg$c13 = "]";
      var peg$c14 = ".";
      var peg$c15 = "e";
      var peg$c16 = "true";
      var peg$c17 = "false";
      var peg$c18 = "null";
      var peg$c21 = "_";
      var peg$c22 = "+";
      var peg$c23 = "-";
      var peg$c24 = "'";
      var peg$c25 = " ";
      var peg$r0 = /^[^']/;
      var peg$r1 = /^[A-Z]/;
      var peg$r2 = /^[a-z]/;
      var peg$r3 = /^[0-9]/;
      var peg$e0 = peg$literalExpectation(",", false);
      var peg$e1 = peg$literalExpectation("(", false);
      var peg$e2 = peg$literalExpectation(")", false);
      var peg$e3 = peg$literalExpectation("in", false);
      var peg$e4 = peg$literalExpectation("eq", false);
      var peg$e5 = peg$literalExpectation("ne", false);
      var peg$e6 = peg$literalExpectation("gt", false);
      var peg$e7 = peg$literalExpectation("ge", false);
      var peg$e8 = peg$literalExpectation("lt", false);
      var peg$e9 = peg$literalExpectation("le", false);
      var peg$e10 = peg$literalExpectation("and", false);
      var peg$e11 = peg$literalExpectation("or", false);
      var peg$e12 = peg$literalExpectation("[", false);
      var peg$e13 = peg$literalExpectation("]", false);
      var peg$e14 = peg$classExpectation(["'"], true, false);
      var peg$e15 = peg$literalExpectation(".", false);
      var peg$e16 = peg$literalExpectation("e", true);
      var peg$e17 = peg$literalExpectation("true", true);
      var peg$e18 = peg$literalExpectation("false", true);
      var peg$e19 = peg$literalExpectation("null", false);
      var peg$e22 = peg$literalExpectation("_", false);
      var peg$e23 = peg$literalExpectation("+", false);
      var peg$e24 = peg$literalExpectation("-", false);
      var peg$e25 = peg$classExpectation([["A", "Z"]], false, false);
      var peg$e26 = peg$classExpectation([["a", "z"]], false, false);
      var peg$e27 = peg$classExpectation([["0", "9"]], false, false);
      var peg$e28 = peg$literalExpectation("'", false);
      var peg$e29 = peg$literalExpectation(" ", false);
      var peg$f4 = function(value) {
        return value;
      };
      var peg$f5 = function(value) {
        return {
          // @ts-ignore
          type: "MemberExpr",
          // @ts-ignore
          value
        };
      };
      var peg$f6 = function(name, head, arg) {
        return arg;
      };
      var peg$f7 = function(name, head, tail) {
        return {
          // @ts-ignore
          type: "FunctionExpr",
          // @ts-ignore
          name,
          // @ts-ignore
          arguments: [head, ...tail]
        };
      };
      var peg$f8 = function(left, right) {
        return {
          // @ts-ignore
          type: "InExpr",
          // @ts-ignore
          left,
          // @ts-ignore
          right
        };
      };
      var peg$f9 = function(left, right) {
        return {
          // @ts-ignore
          type: "EqExpr",
          // @ts-ignore
          left,
          // @ts-ignore
          right
        };
      };
      var peg$f10 = function(left, right) {
        return {
          // @ts-ignore
          type: "NeExpr",
          // @ts-ignore
          left,
          // @ts-ignore
          right
        };
      };
      var peg$f11 = function(left, right) {
        return {
          // @ts-ignore
          type: "GtExpr",
          // @ts-ignore
          left,
          // @ts-ignore
          right
        };
      };
      var peg$f12 = function(left, right) {
        return {
          // @ts-ignore
          type: "GeExpr",
          // @ts-ignore
          left,
          // @ts-ignore
          right
        };
      };
      var peg$f13 = function(left, right) {
        return {
          // @ts-ignore
          type: "LtExpr",
          // @ts-ignore
          left,
          // @ts-ignore
          right
        };
      };
      var peg$f14 = function(left, right) {
        return {
          // @ts-ignore
          type: "LeExpr",
          // @ts-ignore
          left,
          // @ts-ignore
          right
        };
      };
      var peg$f15 = function(left, right) {
        return {
          // @ts-ignore
          type: "AndExpr",
          // @ts-ignore
          left,
          // @ts-ignore
          right
        };
      };
      var peg$f16 = function(left, right) {
        return {
          // @ts-ignore
          type: "OrExpr",
          // @ts-ignore
          left,
          // @ts-ignore
          right
        };
      };
      var peg$f17 = function(head, elem) {
        return elem;
      };
      var peg$f18 = function(head, tail) {
        return {
          // @ts-ignore
          type: "ArrayExpr",
          // @ts-ignore
          value: [head, ...tail]
        };
      };
      var peg$f19 = function(head, elem) {
        return elem;
      };
      var peg$f20 = function(head, tail) {
        return {
          // @ts-ignore
          type: "ArrayExpr",
          // @ts-ignore
          value: [head, ...tail]
        };
      };
      var peg$f21 = function(value) {
        return {
          // @ts-ignore
          type: "Primitive",
          // @ts-ignore
          value: value.join("")
        };
      };
      var peg$f22 = function() {
        return "'";
      };
      var peg$f23 = function(value) {
        return text();
      };
      var peg$f24 = function() {
        return {
          // @ts-ignore
          type: "Primitive",
          // @ts-ignore
          value: Number.parseFloat(text())
        };
      };
      var peg$f25 = function(value) {
        return {
          // @ts-ignore
          type: "Primitive",
          // @ts-ignore
          value: value === "true" ? true : false
        };
      };
      var peg$f26 = function() {
        return {
          // @ts-ignore
          type: "Primitive",
          // @ts-ignore
          value: null
        };
      };
      var peg$currPos = 0;
      var peg$savedPos = 0;
      var peg$posDetailsCache = [{ line: 1, column: 1 }];
      var peg$maxFailPos = 0;
      var peg$maxFailExpected = [];
      var peg$result;
      if ("startRule" in options) {
        if (!(options.startRule in peg$startRuleFunctions)) {
          throw new Error(`Can't start parsing from rule "` + options.startRule + '".');
        }
        peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
      }
      function text() {
        return input.substring(peg$savedPos, peg$currPos);
      }
      function peg$literalExpectation(text2, ignoreCase) {
        return { type: "literal", text: text2, ignoreCase };
      }
      function peg$classExpectation(parts, inverted, ignoreCase) {
        return { type: "class", parts, inverted, ignoreCase };
      }
      function peg$endExpectation() {
        return { type: "end" };
      }
      function peg$computePosDetails(pos) {
        var details = peg$posDetailsCache[pos];
        var p;
        if (details) {
          return details;
        } else {
          p = pos - 1;
          while (!peg$posDetailsCache[p]) {
            p--;
          }
          details = peg$posDetailsCache[p];
          details = {
            // @ts-ignore
            line: details.line,
            // @ts-ignore
            column: details.column
          };
          while (p < pos) {
            if (input.charCodeAt(p) === 10) {
              details.line++;
              details.column = 1;
            } else {
              details.column++;
            }
            p++;
          }
          peg$posDetailsCache[pos] = details;
          return details;
        }
      }
      function peg$computeLocation(startPos, endPos, offset2) {
        var startPosDetails = peg$computePosDetails(startPos);
        var endPosDetails = peg$computePosDetails(endPos);
        var res = {
          // @ts-ignore
          source: peg$source,
          // @ts-ignore
          start: {
            // @ts-ignore
            offset: startPos,
            // @ts-ignore
            line: startPosDetails.line,
            // @ts-ignore
            column: startPosDetails.column
          },
          // @ts-ignore
          end: {
            // @ts-ignore
            offset: endPos,
            // @ts-ignore
            line: endPosDetails.line,
            // @ts-ignore
            column: endPosDetails.column
          }
        };
        return res;
      }
      function peg$fail(expected2) {
        if (peg$currPos < peg$maxFailPos) {
          return;
        }
        if (peg$currPos > peg$maxFailPos) {
          peg$maxFailPos = peg$currPos;
          peg$maxFailExpected = [];
        }
        peg$maxFailExpected.push(expected2);
      }
      function peg$buildStructuredError(expected2, found, location2) {
        return new peg$SyntaxError(
          // @ts-ignore
          peg$SyntaxError.buildMessage(expected2, found),
          // @ts-ignore
          expected2,
          // @ts-ignore
          found,
          // @ts-ignore
          location2
        );
      }
      function peg$parseFilter() {
        var s0;
        s0 = peg$parseOrExpr();
        return s0;
      }
      function peg$parseParenExpr() {
        var s0, s1, s3, s5;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 40) {
          s1 = peg$c1;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          {
            peg$fail(peg$e1);
          }
        }
        if (s1 !== peg$FAILED) {
          peg$parseOWS();
          s3 = peg$parseOrExpr();
          if (s3 !== peg$FAILED) {
            peg$parseOWS();
            if (input.charCodeAt(peg$currPos) === 41) {
              s5 = peg$c2;
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              {
                peg$fail(peg$e2);
              }
            }
            if (s5 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f4(s3);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parsePrimaryExpr() {
        var s0;
        s0 = peg$parseFunctionExpr();
        if (s0 === peg$FAILED) {
          s0 = peg$parseArrayExpr();
          if (s0 === peg$FAILED) {
            s0 = peg$parsePrimitive();
            if (s0 === peg$FAILED) {
              s0 = peg$parseMemberExpr();
            }
          }
        }
        return s0;
      }
      function peg$parseMemberExpr() {
        var s0, s1;
        s0 = peg$currPos;
        s1 = peg$parseOdataIdentifier();
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f5(s1);
        }
        s0 = s1;
        return s0;
      }
      function peg$parseFunctionExpr() {
        var s0, s1, s2, s4, s5, s6, s7, s8, s10;
        s0 = peg$currPos;
        s1 = peg$parseOdataIdentifier();
        if (s1 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 40) {
            s2 = peg$c1;
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            {
              peg$fail(peg$e1);
            }
          }
          if (s2 !== peg$FAILED) {
            peg$parseOWS();
            s4 = peg$parsePrimaryExpr();
            if (s4 !== peg$FAILED) {
              s5 = [];
              s6 = peg$currPos;
              s7 = peg$parseOWS();
              if (input.charCodeAt(peg$currPos) === 44) {
                s8 = peg$c0;
                peg$currPos++;
              } else {
                s8 = peg$FAILED;
                {
                  peg$fail(peg$e0);
                }
              }
              if (s8 !== peg$FAILED) {
                peg$parseOWS();
                s10 = peg$parsePrimaryExpr();
                if (s10 !== peg$FAILED) {
                  peg$savedPos = s6;
                  s6 = peg$f6(s1, s4, s10);
                } else {
                  peg$currPos = s6;
                  s6 = peg$FAILED;
                }
              } else {
                peg$currPos = s6;
                s6 = peg$FAILED;
              }
              while (s6 !== peg$FAILED) {
                s5.push(s6);
                s6 = peg$currPos;
                s7 = peg$parseOWS();
                if (input.charCodeAt(peg$currPos) === 44) {
                  s8 = peg$c0;
                  peg$currPos++;
                } else {
                  s8 = peg$FAILED;
                  {
                    peg$fail(peg$e0);
                  }
                }
                if (s8 !== peg$FAILED) {
                  peg$parseOWS();
                  s10 = peg$parsePrimaryExpr();
                  if (s10 !== peg$FAILED) {
                    peg$savedPos = s6;
                    s6 = peg$f6(s1, s4, s10);
                  } else {
                    peg$currPos = s6;
                    s6 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s6;
                  s6 = peg$FAILED;
                }
              }
              s6 = peg$parseOWS();
              if (input.charCodeAt(peg$currPos) === 41) {
                s7 = peg$c2;
                peg$currPos++;
              } else {
                s7 = peg$FAILED;
                {
                  peg$fail(peg$e2);
                }
              }
              if (s7 !== peg$FAILED) {
                peg$savedPos = s0;
                s0 = peg$f7(s1, s4, s5);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseRelationalExpr() {
        var s0;
        s0 = peg$parseParenExpr();
        if (s0 === peg$FAILED) {
          s0 = peg$parseInExpr();
          if (s0 === peg$FAILED) {
            s0 = peg$parseEqExpr();
            if (s0 === peg$FAILED) {
              s0 = peg$parseNeExpr();
              if (s0 === peg$FAILED) {
                s0 = peg$parseGtExpr();
                if (s0 === peg$FAILED) {
                  s0 = peg$parseGeExpr();
                  if (s0 === peg$FAILED) {
                    s0 = peg$parseLtExpr();
                    if (s0 === peg$FAILED) {
                      s0 = peg$parseLeExpr();
                      if (s0 === peg$FAILED) {
                        s0 = peg$parseFunctionExpr();
                      }
                    }
                  }
                }
              }
            }
          }
        }
        return s0;
      }
      function peg$parseInExpr() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parsePrimaryExpr();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseRWS();
          if (s2 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c3) {
              s3 = peg$c3;
              peg$currPos += 2;
            } else {
              s3 = peg$FAILED;
              {
                peg$fail(peg$e3);
              }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseRWS();
              if (s4 !== peg$FAILED) {
                s5 = peg$parseArrayExpr();
                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f8(s1, s5);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseEqExpr() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parsePrimaryExpr();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseRWS();
          if (s2 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c4) {
              s3 = peg$c4;
              peg$currPos += 2;
            } else {
              s3 = peg$FAILED;
              {
                peg$fail(peg$e4);
              }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseRWS();
              if (s4 !== peg$FAILED) {
                s5 = peg$parsePrimaryExpr();
                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f9(s1, s5);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseNeExpr() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parsePrimaryExpr();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseRWS();
          if (s2 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c5) {
              s3 = peg$c5;
              peg$currPos += 2;
            } else {
              s3 = peg$FAILED;
              {
                peg$fail(peg$e5);
              }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseRWS();
              if (s4 !== peg$FAILED) {
                s5 = peg$parsePrimaryExpr();
                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f10(s1, s5);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseGtExpr() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parsePrimaryExpr();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseRWS();
          if (s2 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c6) {
              s3 = peg$c6;
              peg$currPos += 2;
            } else {
              s3 = peg$FAILED;
              {
                peg$fail(peg$e6);
              }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseRWS();
              if (s4 !== peg$FAILED) {
                s5 = peg$parsePrimaryExpr();
                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f11(s1, s5);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseGeExpr() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parsePrimaryExpr();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseRWS();
          if (s2 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c7) {
              s3 = peg$c7;
              peg$currPos += 2;
            } else {
              s3 = peg$FAILED;
              {
                peg$fail(peg$e7);
              }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseRWS();
              if (s4 !== peg$FAILED) {
                s5 = peg$parsePrimaryExpr();
                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f12(s1, s5);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseLtExpr() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parsePrimaryExpr();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseRWS();
          if (s2 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c8) {
              s3 = peg$c8;
              peg$currPos += 2;
            } else {
              s3 = peg$FAILED;
              {
                peg$fail(peg$e8);
              }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseRWS();
              if (s4 !== peg$FAILED) {
                s5 = peg$parsePrimaryExpr();
                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f13(s1, s5);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseLeExpr() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parsePrimaryExpr();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseRWS();
          if (s2 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c9) {
              s3 = peg$c9;
              peg$currPos += 2;
            } else {
              s3 = peg$FAILED;
              {
                peg$fail(peg$e9);
              }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseRWS();
              if (s4 !== peg$FAILED) {
                s5 = peg$parsePrimaryExpr();
                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f14(s1, s5);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseAndExpr() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseRelationalExpr();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseRWS();
          if (s2 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c10) {
              s3 = peg$c10;
              peg$currPos += 3;
            } else {
              s3 = peg$FAILED;
              {
                peg$fail(peg$e10);
              }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseRWS();
              if (s4 !== peg$FAILED) {
                s5 = peg$parseAndExpr();
                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f15(s1, s5);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$parseRelationalExpr();
        }
        return s0;
      }
      function peg$parseOrExpr() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseAndExpr();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseRWS();
          if (s2 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c11) {
              s3 = peg$c11;
              peg$currPos += 2;
            } else {
              s3 = peg$FAILED;
              {
                peg$fail(peg$e11);
              }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseRWS();
              if (s4 !== peg$FAILED) {
                s5 = peg$parseOrExpr();
                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f16(s1, s5);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$parseAndExpr();
        }
        return s0;
      }
      function peg$parseArrayExpr() {
        var s0;
        s0 = peg$parseArrayCollectionExpr();
        if (s0 === peg$FAILED) {
          s0 = peg$parseArrayJsonExpr();
        }
        return s0;
      }
      function peg$parseArrayCollectionExpr() {
        var s0, s1, s3, s4, s5, s6, s7, s9;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 40) {
          s1 = peg$c1;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          {
            peg$fail(peg$e1);
          }
        }
        if (s1 !== peg$FAILED) {
          peg$parseOWS();
          s3 = peg$parsePrimitive();
          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$currPos;
            s6 = peg$parseOWS();
            if (input.charCodeAt(peg$currPos) === 44) {
              s7 = peg$c0;
              peg$currPos++;
            } else {
              s7 = peg$FAILED;
              {
                peg$fail(peg$e0);
              }
            }
            if (s7 !== peg$FAILED) {
              peg$parseOWS();
              s9 = peg$parsePrimitive();
              if (s9 !== peg$FAILED) {
                peg$savedPos = s5;
                s5 = peg$f17(s3, s9);
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$currPos;
              s6 = peg$parseOWS();
              if (input.charCodeAt(peg$currPos) === 44) {
                s7 = peg$c0;
                peg$currPos++;
              } else {
                s7 = peg$FAILED;
                {
                  peg$fail(peg$e0);
                }
              }
              if (s7 !== peg$FAILED) {
                peg$parseOWS();
                s9 = peg$parsePrimitive();
                if (s9 !== peg$FAILED) {
                  peg$savedPos = s5;
                  s5 = peg$f17(s3, s9);
                } else {
                  peg$currPos = s5;
                  s5 = peg$FAILED;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            }
            s5 = peg$parseOWS();
            if (input.charCodeAt(peg$currPos) === 41) {
              s6 = peg$c2;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              {
                peg$fail(peg$e2);
              }
            }
            if (s6 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f18(s3, s4);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseArrayJsonExpr() {
        var s0, s1, s3, s4, s5, s6, s7, s9;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 91) {
          s1 = peg$c12;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          {
            peg$fail(peg$e12);
          }
        }
        if (s1 !== peg$FAILED) {
          peg$parseOWS();
          s3 = peg$parsePrimitive();
          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$currPos;
            s6 = peg$parseOWS();
            if (input.charCodeAt(peg$currPos) === 44) {
              s7 = peg$c0;
              peg$currPos++;
            } else {
              s7 = peg$FAILED;
              {
                peg$fail(peg$e0);
              }
            }
            if (s7 !== peg$FAILED) {
              peg$parseOWS();
              s9 = peg$parsePrimitive();
              if (s9 !== peg$FAILED) {
                peg$savedPos = s5;
                s5 = peg$f19(s3, s9);
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$currPos;
              s6 = peg$parseOWS();
              if (input.charCodeAt(peg$currPos) === 44) {
                s7 = peg$c0;
                peg$currPos++;
              } else {
                s7 = peg$FAILED;
                {
                  peg$fail(peg$e0);
                }
              }
              if (s7 !== peg$FAILED) {
                peg$parseOWS();
                s9 = peg$parsePrimitive();
                if (s9 !== peg$FAILED) {
                  peg$savedPos = s5;
                  s5 = peg$f19(s3, s9);
                } else {
                  peg$currPos = s5;
                  s5 = peg$FAILED;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            }
            s5 = peg$parseOWS();
            if (input.charCodeAt(peg$currPos) === 93) {
              s6 = peg$c13;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              {
                peg$fail(peg$e13);
              }
            }
            if (s6 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f20(s3, s4);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parsePrimitive() {
        var s0;
        s0 = peg$parseString();
        if (s0 === peg$FAILED) {
          s0 = peg$parseNumber();
          if (s0 === peg$FAILED) {
            s0 = peg$parseBoolean();
            if (s0 === peg$FAILED) {
              s0 = peg$parseNull();
            }
          }
        }
        return s0;
      }
      function peg$parseString() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$parseSQUOTE();
        if (s1 !== peg$FAILED) {
          s2 = [];
          s3 = peg$parseSquoteInString();
          if (s3 === peg$FAILED) {
            s3 = peg$parseStringNoSquote();
          }
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseSquoteInString();
            if (s3 === peg$FAILED) {
              s3 = peg$parseStringNoSquote();
            }
          }
          s3 = peg$parseSQUOTE();
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f21(s2);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseSquoteInString() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parseSQUOTE();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseSQUOTE();
          if (s2 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f22();
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseStringNoSquote() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = [];
        if (peg$r0.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          {
            peg$fail(peg$e14);
          }
        }
        if (s2 !== peg$FAILED) {
          while (s2 !== peg$FAILED) {
            s1.push(s2);
            if (peg$r0.test(input.charAt(peg$currPos))) {
              s2 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
              {
                peg$fail(peg$e14);
              }
            }
          }
        } else {
          s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f23();
        }
        s0 = s1;
        return s0;
      }
      function peg$parseNumber() {
        var s0, s2, s3, s4, s5, s6, s7, s8;
        s0 = peg$currPos;
        peg$parseSIGN();
        s2 = [];
        s3 = peg$parseDIGIT();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseDIGIT();
          }
        } else {
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 46) {
            s4 = peg$c14;
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            {
              peg$fail(peg$e15);
            }
          }
          if (s4 !== peg$FAILED) {
            s5 = [];
            s6 = peg$parseDIGIT();
            if (s6 !== peg$FAILED) {
              while (s6 !== peg$FAILED) {
                s5.push(s6);
                s6 = peg$parseDIGIT();
              }
            } else {
              s5 = peg$FAILED;
            }
            if (s5 !== peg$FAILED) {
              s4 = [s4, s5];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
          if (s3 === peg$FAILED) {
            s3 = null;
          }
          s4 = peg$currPos;
          if (input.substr(peg$currPos, 1).toLowerCase() === peg$c15) {
            s5 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            {
              peg$fail(peg$e16);
            }
          }
          if (s5 !== peg$FAILED) {
            s6 = peg$parseSIGN();
            if (s6 === peg$FAILED) {
              s6 = null;
            }
            s7 = [];
            s8 = peg$parseDIGIT();
            if (s8 !== peg$FAILED) {
              while (s8 !== peg$FAILED) {
                s7.push(s8);
                s8 = peg$parseDIGIT();
              }
            } else {
              s7 = peg$FAILED;
            }
            if (s7 !== peg$FAILED) {
              s5 = [s5, s6, s7];
              s4 = s5;
            } else {
              peg$currPos = s4;
              s4 = peg$FAILED;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$FAILED;
          }
          if (s4 === peg$FAILED) {
            s4 = null;
          }
          peg$savedPos = s0;
          s0 = peg$f24();
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseBoolean() {
        var s0, s1;
        s0 = peg$currPos;
        if (input.substr(peg$currPos, 4).toLowerCase() === peg$c16) {
          s1 = input.substr(peg$currPos, 4);
          peg$currPos += 4;
        } else {
          s1 = peg$FAILED;
          {
            peg$fail(peg$e17);
          }
        }
        if (s1 === peg$FAILED) {
          if (input.substr(peg$currPos, 5).toLowerCase() === peg$c17) {
            s1 = input.substr(peg$currPos, 5);
            peg$currPos += 5;
          } else {
            s1 = peg$FAILED;
            {
              peg$fail(peg$e18);
            }
          }
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f25(s1);
        }
        s0 = s1;
        return s0;
      }
      function peg$parseNull() {
        var s0, s1;
        s0 = peg$currPos;
        if (input.substr(peg$currPos, 4) === peg$c18) {
          s1 = peg$c18;
          peg$currPos += 4;
        } else {
          s1 = peg$FAILED;
          {
            peg$fail(peg$e19);
          }
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f26();
        }
        s0 = s1;
        return s0;
      }
      function peg$parseOdataIdentifier() {
        var s0, s1, s2, s3, s4;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseIdentifierLeadingCharacter();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseIdentifierCharacter();
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$parseIdentifierCharacter();
          }
          s2 = [s2, s3];
          s1 = s2;
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
          s0 = input.substring(s0, peg$currPos);
        } else {
          s0 = s1;
        }
        return s0;
      }
      function peg$parseIdentifierLeadingCharacter() {
        var s0;
        s0 = peg$parseALPHA();
        if (s0 === peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 95) {
            s0 = peg$c21;
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            {
              peg$fail(peg$e22);
            }
          }
        }
        return s0;
      }
      function peg$parseIdentifierCharacter() {
        var s0;
        s0 = peg$parseALPHA();
        if (s0 === peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 95) {
            s0 = peg$c21;
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            {
              peg$fail(peg$e22);
            }
          }
          if (s0 === peg$FAILED) {
            s0 = peg$parseDIGIT();
          }
        }
        return s0;
      }
      function peg$parseSIGN() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 43) {
          s0 = peg$c22;
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e23);
          }
        }
        if (s0 === peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 45) {
            s0 = peg$c23;
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            {
              peg$fail(peg$e24);
            }
          }
        }
        return s0;
      }
      function peg$parseALPHA() {
        var s0;
        if (peg$r1.test(input.charAt(peg$currPos))) {
          s0 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e25);
          }
        }
        if (s0 === peg$FAILED) {
          if (peg$r2.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            {
              peg$fail(peg$e26);
            }
          }
        }
        return s0;
      }
      function peg$parseDIGIT() {
        var s0;
        if (peg$r3.test(input.charAt(peg$currPos))) {
          s0 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e27);
          }
        }
        return s0;
      }
      function peg$parseSQUOTE() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 39) {
          s0 = peg$c24;
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e28);
          }
        }
        return s0;
      }
      function peg$parseSP() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 32) {
          s0 = peg$c25;
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e29);
          }
        }
        return s0;
      }
      function peg$parseOWS() {
        var s0, s1;
        s0 = [];
        s1 = peg$parseSP();
        while (s1 !== peg$FAILED) {
          s0.push(s1);
          s1 = peg$parseSP();
        }
        return s0;
      }
      function peg$parseRWS() {
        var s0, s1;
        s0 = [];
        s1 = peg$parseSP();
        if (s1 !== peg$FAILED) {
          while (s1 !== peg$FAILED) {
            s0.push(s1);
            s1 = peg$parseSP();
          }
        } else {
          s0 = peg$FAILED;
        }
        return s0;
      }
      peg$result = peg$startRuleFunction();
      if (peg$result !== peg$FAILED && peg$currPos === input.length) {
        return peg$result;
      } else {
        if (peg$result !== peg$FAILED && peg$currPos < input.length) {
          peg$fail(peg$endExpectation());
        }
        throw peg$buildStructuredError(
          // @ts-ignore
          peg$maxFailExpected,
          // @ts-ignore
          peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null,
          // @ts-ignore
          peg$maxFailPos < input.length ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1) : peg$computeLocation(peg$maxFailPos, peg$maxFailPos)
        );
      }
    }
    return {
      SyntaxError: peg$SyntaxError,
      parse: peg$parse
    };
  }()
);
peggyParser$1.SyntaxError.prototype.name = "PeggySyntaxError";
const parse$1 = peggyParser$1.parse;

const peggyParser = (
  // Generated by Peggy 3.0.2.
  //
  // https://peggyjs.org/
  // @ts-ignore
  function() {
    function peg$subclass(child, parent) {
      function C() {
        this.constructor = child;
      }
      C.prototype = parent.prototype;
      child.prototype = new C();
    }
    function peg$SyntaxError(message, expected, found, location) {
      var self = Error.call(this, message);
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(self, peg$SyntaxError.prototype);
      }
      self.expected = expected;
      self.found = found;
      self.location = location;
      self.name = "SyntaxError";
      return self;
    }
    peg$subclass(peg$SyntaxError, Error);
    function peg$padEnd(str, targetLength, padString) {
      padString = padString || " ";
      if (str.length > targetLength) {
        return str;
      }
      targetLength -= str.length;
      padString += padString.repeat(targetLength);
      return str + padString.slice(0, targetLength);
    }
    peg$SyntaxError.prototype.format = function(sources) {
      var str = "Error: " + this.message;
      if (this.location) {
        var src = null;
        var k;
        for (k = 0; k < sources.length; k++) {
          if (sources[k].source === this.location.source) {
            src = sources[k].text.split(/\r\n|\n|\r/g);
            break;
          }
        }
        var s = this.location.start;
        var offset_s = this.location.source && typeof this.location.source.offset === "function" ? this.location.source.offset(s) : s;
        var loc = this.location.source + ":" + offset_s.line + ":" + offset_s.column;
        if (src) {
          var e = this.location.end;
          var filler = peg$padEnd("", offset_s.line.toString().length, " ");
          var line = src[s.line - 1];
          var last = s.line === e.line ? e.column : line.length + 1;
          var hatLen = last - s.column || 1;
          str += "\n --> " + loc + "\n" + filler + " |\n" + offset_s.line + " | " + line + "\n" + filler + " | " + peg$padEnd("", s.column - 1, " ") + peg$padEnd("", hatLen, "^");
        } else {
          str += "\n at " + loc;
        }
      }
      return str;
    };
    peg$SyntaxError.buildMessage = function(expected, found) {
      var DESCRIBE_EXPECTATION_FNS = {
        // @ts-ignore
        literal: function(expectation) {
          return '"' + literalEscape(expectation.text) + '"';
        },
        // @ts-ignore
        class: function(expectation) {
          var escapedParts = expectation.parts.map(function(part) {
            return Array.isArray(part) ? classEscape(part[0]) + "-" + classEscape(part[1]) : classEscape(part);
          });
          return "[" + (expectation.inverted ? "^" : "") + escapedParts.join("") + "]";
        },
        // @ts-ignore
        any: function() {
          return "any character";
        },
        // @ts-ignore
        end: function() {
          return "end of input";
        },
        // @ts-ignore
        other: function(expectation) {
          return expectation.description;
        }
      };
      function hex(ch) {
        return ch.charCodeAt(0).toString(16).toUpperCase();
      }
      function literalEscape(s) {
        return s.replace(/\\/g, "\\\\").replace(/"/g, '\\"').replace(/\0/g, "\\0").replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r").replace(/[\x00-\x0F]/g, function(ch) {
          return "\\x0" + hex(ch);
        }).replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) {
          return "\\x" + hex(ch);
        });
      }
      function classEscape(s) {
        return s.replace(/\\/g, "\\\\").replace(/\]/g, "\\]").replace(/\^/g, "\\^").replace(/-/g, "\\-").replace(/\0/g, "\\0").replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r").replace(/[\x00-\x0F]/g, function(ch) {
          return "\\x0" + hex(ch);
        }).replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) {
          return "\\x" + hex(ch);
        });
      }
      function describeExpectation(expectation) {
        return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
      }
      function describeExpected(expected2) {
        var descriptions = expected2.map(describeExpectation);
        var i, j;
        descriptions.sort();
        if (descriptions.length > 0) {
          for (i = 1, j = 1; i < descriptions.length; i++) {
            if (descriptions[i - 1] !== descriptions[i]) {
              descriptions[j] = descriptions[i];
              j++;
            }
          }
          descriptions.length = j;
        }
        switch (descriptions.length) {
          // @ts-ignore
          case 1:
            return descriptions[0];
          // @ts-ignore
          case 2:
            return descriptions[0] + " or " + descriptions[1];
          // @ts-ignore
          default:
            return descriptions.slice(0, -1).join(", ") + ", or " + descriptions[descriptions.length - 1];
        }
      }
      function describeFound(found2) {
        return found2 ? '"' + literalEscape(found2) + '"' : "end of input";
      }
      return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
    };
    function peg$parse(input, options) {
      options = options !== void 0 ? options : {};
      var peg$FAILED = {};
      var peg$source = options.grammarSource;
      var peg$startRuleFunctions = { OrderBy: peg$parseOrderBy };
      var peg$startRuleFunction = peg$parseOrderBy;
      var peg$c0 = ",";
      var peg$c1 = "(";
      var peg$c2 = ")";
      var peg$c12 = "[";
      var peg$c13 = "]";
      var peg$c14 = ".";
      var peg$c15 = "e";
      var peg$c16 = "true";
      var peg$c17 = "false";
      var peg$c18 = "null";
      var peg$c19 = "asc";
      var peg$c20 = "desc";
      var peg$c21 = "_";
      var peg$c22 = "+";
      var peg$c23 = "-";
      var peg$c24 = "'";
      var peg$c25 = " ";
      var peg$r0 = /^[^']/;
      var peg$r1 = /^[A-Z]/;
      var peg$r2 = /^[a-z]/;
      var peg$r3 = /^[0-9]/;
      var peg$e0 = peg$literalExpectation(",", false);
      var peg$e1 = peg$literalExpectation("(", false);
      var peg$e2 = peg$literalExpectation(")", false);
      var peg$e12 = peg$literalExpectation("[", false);
      var peg$e13 = peg$literalExpectation("]", false);
      var peg$e14 = peg$classExpectation(["'"], true, false);
      var peg$e15 = peg$literalExpectation(".", false);
      var peg$e16 = peg$literalExpectation("e", true);
      var peg$e17 = peg$literalExpectation("true", true);
      var peg$e18 = peg$literalExpectation("false", true);
      var peg$e19 = peg$literalExpectation("null", false);
      var peg$e20 = peg$literalExpectation("asc", false);
      var peg$e21 = peg$literalExpectation("desc", false);
      var peg$e22 = peg$literalExpectation("_", false);
      var peg$e23 = peg$literalExpectation("+", false);
      var peg$e24 = peg$literalExpectation("-", false);
      var peg$e25 = peg$classExpectation([["A", "Z"]], false, false);
      var peg$e26 = peg$classExpectation([["a", "z"]], false, false);
      var peg$e27 = peg$classExpectation([["0", "9"]], false, false);
      var peg$e28 = peg$literalExpectation("'", false);
      var peg$e29 = peg$literalExpectation(" ", false);
      var peg$f0 = function(head, elem) {
        return elem;
      };
      var peg$f1 = function(head, tail) {
        return [head, ...tail];
      };
      var peg$f2 = function(expr, dir) {
        return dir;
      };
      var peg$f3 = function(expr, dir) {
        return {
          // @ts-ignore
          type: "OrderByItem",
          // @ts-ignore
          expr,
          // @ts-ignore
          dir: dir ?? "asc"
        };
      };
      var peg$f5 = function(value) {
        return {
          // @ts-ignore
          type: "MemberExpr",
          // @ts-ignore
          value
        };
      };
      var peg$f6 = function(name, head, arg) {
        return arg;
      };
      var peg$f7 = function(name, head, tail) {
        return {
          // @ts-ignore
          type: "FunctionExpr",
          // @ts-ignore
          name,
          // @ts-ignore
          arguments: [head, ...tail]
        };
      };
      var peg$f17 = function(head, elem) {
        return elem;
      };
      var peg$f18 = function(head, tail) {
        return {
          // @ts-ignore
          type: "ArrayExpr",
          // @ts-ignore
          value: [head, ...tail]
        };
      };
      var peg$f19 = function(head, elem) {
        return elem;
      };
      var peg$f20 = function(head, tail) {
        return {
          // @ts-ignore
          type: "ArrayExpr",
          // @ts-ignore
          value: [head, ...tail]
        };
      };
      var peg$f21 = function(value) {
        return {
          // @ts-ignore
          type: "Primitive",
          // @ts-ignore
          value: value.join("")
        };
      };
      var peg$f22 = function() {
        return "'";
      };
      var peg$f23 = function(value) {
        return text();
      };
      var peg$f24 = function() {
        return {
          // @ts-ignore
          type: "Primitive",
          // @ts-ignore
          value: Number.parseFloat(text())
        };
      };
      var peg$f25 = function(value) {
        return {
          // @ts-ignore
          type: "Primitive",
          // @ts-ignore
          value: value === "true" ? true : false
        };
      };
      var peg$f26 = function() {
        return {
          // @ts-ignore
          type: "Primitive",
          // @ts-ignore
          value: null
        };
      };
      var peg$currPos = 0;
      var peg$savedPos = 0;
      var peg$posDetailsCache = [{ line: 1, column: 1 }];
      var peg$maxFailPos = 0;
      var peg$maxFailExpected = [];
      var peg$result;
      if ("startRule" in options) {
        if (!(options.startRule in peg$startRuleFunctions)) {
          throw new Error(`Can't start parsing from rule "` + options.startRule + '".');
        }
        peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
      }
      function text() {
        return input.substring(peg$savedPos, peg$currPos);
      }
      function peg$literalExpectation(text2, ignoreCase) {
        return { type: "literal", text: text2, ignoreCase };
      }
      function peg$classExpectation(parts, inverted, ignoreCase) {
        return { type: "class", parts, inverted, ignoreCase };
      }
      function peg$endExpectation() {
        return { type: "end" };
      }
      function peg$computePosDetails(pos) {
        var details = peg$posDetailsCache[pos];
        var p;
        if (details) {
          return details;
        } else {
          p = pos - 1;
          while (!peg$posDetailsCache[p]) {
            p--;
          }
          details = peg$posDetailsCache[p];
          details = {
            // @ts-ignore
            line: details.line,
            // @ts-ignore
            column: details.column
          };
          while (p < pos) {
            if (input.charCodeAt(p) === 10) {
              details.line++;
              details.column = 1;
            } else {
              details.column++;
            }
            p++;
          }
          peg$posDetailsCache[pos] = details;
          return details;
        }
      }
      function peg$computeLocation(startPos, endPos, offset2) {
        var startPosDetails = peg$computePosDetails(startPos);
        var endPosDetails = peg$computePosDetails(endPos);
        var res = {
          // @ts-ignore
          source: peg$source,
          // @ts-ignore
          start: {
            // @ts-ignore
            offset: startPos,
            // @ts-ignore
            line: startPosDetails.line,
            // @ts-ignore
            column: startPosDetails.column
          },
          // @ts-ignore
          end: {
            // @ts-ignore
            offset: endPos,
            // @ts-ignore
            line: endPosDetails.line,
            // @ts-ignore
            column: endPosDetails.column
          }
        };
        return res;
      }
      function peg$fail(expected2) {
        if (peg$currPos < peg$maxFailPos) {
          return;
        }
        if (peg$currPos > peg$maxFailPos) {
          peg$maxFailPos = peg$currPos;
          peg$maxFailExpected = [];
        }
        peg$maxFailExpected.push(expected2);
      }
      function peg$buildStructuredError(expected2, found, location2) {
        return new peg$SyntaxError(
          // @ts-ignore
          peg$SyntaxError.buildMessage(expected2, found),
          // @ts-ignore
          expected2,
          // @ts-ignore
          found,
          // @ts-ignore
          location2
        );
      }
      function peg$parseOrderBy() {
        var s0, s1, s2, s3, s5, s7;
        s0 = peg$currPos;
        s1 = peg$parseOrderByItem();
        if (s1 !== peg$FAILED) {
          s2 = [];
          s3 = peg$currPos;
          peg$parseOWS();
          if (input.charCodeAt(peg$currPos) === 44) {
            s5 = peg$c0;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            {
              peg$fail(peg$e0);
            }
          }
          if (s5 !== peg$FAILED) {
            peg$parseOWS();
            s7 = peg$parseOrderByItem();
            if (s7 !== peg$FAILED) {
              peg$savedPos = s3;
              s3 = peg$f0(s1, s7);
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            peg$parseOWS();
            if (input.charCodeAt(peg$currPos) === 44) {
              s5 = peg$c0;
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              {
                peg$fail(peg$e0);
              }
            }
            if (s5 !== peg$FAILED) {
              peg$parseOWS();
              s7 = peg$parseOrderByItem();
              if (s7 !== peg$FAILED) {
                peg$savedPos = s3;
                s3 = peg$f0(s1, s7);
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          }
          s3 = peg$parseOWS();
          peg$savedPos = s0;
          s0 = peg$f1(s1, s2);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseOrderByItem() {
        var s0, s1, s2, s3, s4;
        s0 = peg$currPos;
        s1 = peg$parsePrimaryExpr();
        if (s1 !== peg$FAILED) {
          s2 = peg$currPos;
          s3 = peg$parseRWS();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseDirection();
            if (s4 !== peg$FAILED) {
              peg$savedPos = s2;
              s2 = peg$f2(s1, s4);
            } else {
              peg$currPos = s2;
              s2 = peg$FAILED;
            }
          } else {
            peg$currPos = s2;
            s2 = peg$FAILED;
          }
          if (s2 === peg$FAILED) {
            s2 = null;
          }
          peg$savedPos = s0;
          s0 = peg$f3(s1, s2);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parsePrimaryExpr() {
        var s0;
        s0 = peg$parseFunctionExpr();
        if (s0 === peg$FAILED) {
          s0 = peg$parseArrayExpr();
          if (s0 === peg$FAILED) {
            s0 = peg$parsePrimitive();
            if (s0 === peg$FAILED) {
              s0 = peg$parseMemberExpr();
            }
          }
        }
        return s0;
      }
      function peg$parseMemberExpr() {
        var s0, s1;
        s0 = peg$currPos;
        s1 = peg$parseOdataIdentifier();
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f5(s1);
        }
        s0 = s1;
        return s0;
      }
      function peg$parseFunctionExpr() {
        var s0, s1, s2, s4, s5, s6, s7, s8, s10;
        s0 = peg$currPos;
        s1 = peg$parseOdataIdentifier();
        if (s1 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 40) {
            s2 = peg$c1;
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            {
              peg$fail(peg$e1);
            }
          }
          if (s2 !== peg$FAILED) {
            peg$parseOWS();
            s4 = peg$parsePrimaryExpr();
            if (s4 !== peg$FAILED) {
              s5 = [];
              s6 = peg$currPos;
              s7 = peg$parseOWS();
              if (input.charCodeAt(peg$currPos) === 44) {
                s8 = peg$c0;
                peg$currPos++;
              } else {
                s8 = peg$FAILED;
                {
                  peg$fail(peg$e0);
                }
              }
              if (s8 !== peg$FAILED) {
                peg$parseOWS();
                s10 = peg$parsePrimaryExpr();
                if (s10 !== peg$FAILED) {
                  peg$savedPos = s6;
                  s6 = peg$f6(s1, s4, s10);
                } else {
                  peg$currPos = s6;
                  s6 = peg$FAILED;
                }
              } else {
                peg$currPos = s6;
                s6 = peg$FAILED;
              }
              while (s6 !== peg$FAILED) {
                s5.push(s6);
                s6 = peg$currPos;
                s7 = peg$parseOWS();
                if (input.charCodeAt(peg$currPos) === 44) {
                  s8 = peg$c0;
                  peg$currPos++;
                } else {
                  s8 = peg$FAILED;
                  {
                    peg$fail(peg$e0);
                  }
                }
                if (s8 !== peg$FAILED) {
                  peg$parseOWS();
                  s10 = peg$parsePrimaryExpr();
                  if (s10 !== peg$FAILED) {
                    peg$savedPos = s6;
                    s6 = peg$f6(s1, s4, s10);
                  } else {
                    peg$currPos = s6;
                    s6 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s6;
                  s6 = peg$FAILED;
                }
              }
              s6 = peg$parseOWS();
              if (input.charCodeAt(peg$currPos) === 41) {
                s7 = peg$c2;
                peg$currPos++;
              } else {
                s7 = peg$FAILED;
                {
                  peg$fail(peg$e2);
                }
              }
              if (s7 !== peg$FAILED) {
                peg$savedPos = s0;
                s0 = peg$f7(s1, s4, s5);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseArrayExpr() {
        var s0;
        s0 = peg$parseArrayCollectionExpr();
        if (s0 === peg$FAILED) {
          s0 = peg$parseArrayJsonExpr();
        }
        return s0;
      }
      function peg$parseArrayCollectionExpr() {
        var s0, s1, s3, s4, s5, s6, s7, s9;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 40) {
          s1 = peg$c1;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          {
            peg$fail(peg$e1);
          }
        }
        if (s1 !== peg$FAILED) {
          peg$parseOWS();
          s3 = peg$parsePrimitive();
          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$currPos;
            s6 = peg$parseOWS();
            if (input.charCodeAt(peg$currPos) === 44) {
              s7 = peg$c0;
              peg$currPos++;
            } else {
              s7 = peg$FAILED;
              {
                peg$fail(peg$e0);
              }
            }
            if (s7 !== peg$FAILED) {
              peg$parseOWS();
              s9 = peg$parsePrimitive();
              if (s9 !== peg$FAILED) {
                peg$savedPos = s5;
                s5 = peg$f17(s3, s9);
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$currPos;
              s6 = peg$parseOWS();
              if (input.charCodeAt(peg$currPos) === 44) {
                s7 = peg$c0;
                peg$currPos++;
              } else {
                s7 = peg$FAILED;
                {
                  peg$fail(peg$e0);
                }
              }
              if (s7 !== peg$FAILED) {
                peg$parseOWS();
                s9 = peg$parsePrimitive();
                if (s9 !== peg$FAILED) {
                  peg$savedPos = s5;
                  s5 = peg$f17(s3, s9);
                } else {
                  peg$currPos = s5;
                  s5 = peg$FAILED;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            }
            s5 = peg$parseOWS();
            if (input.charCodeAt(peg$currPos) === 41) {
              s6 = peg$c2;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              {
                peg$fail(peg$e2);
              }
            }
            if (s6 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f18(s3, s4);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseArrayJsonExpr() {
        var s0, s1, s3, s4, s5, s6, s7, s9;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 91) {
          s1 = peg$c12;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          {
            peg$fail(peg$e12);
          }
        }
        if (s1 !== peg$FAILED) {
          peg$parseOWS();
          s3 = peg$parsePrimitive();
          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$currPos;
            s6 = peg$parseOWS();
            if (input.charCodeAt(peg$currPos) === 44) {
              s7 = peg$c0;
              peg$currPos++;
            } else {
              s7 = peg$FAILED;
              {
                peg$fail(peg$e0);
              }
            }
            if (s7 !== peg$FAILED) {
              peg$parseOWS();
              s9 = peg$parsePrimitive();
              if (s9 !== peg$FAILED) {
                peg$savedPos = s5;
                s5 = peg$f19(s3, s9);
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$currPos;
              s6 = peg$parseOWS();
              if (input.charCodeAt(peg$currPos) === 44) {
                s7 = peg$c0;
                peg$currPos++;
              } else {
                s7 = peg$FAILED;
                {
                  peg$fail(peg$e0);
                }
              }
              if (s7 !== peg$FAILED) {
                peg$parseOWS();
                s9 = peg$parsePrimitive();
                if (s9 !== peg$FAILED) {
                  peg$savedPos = s5;
                  s5 = peg$f19(s3, s9);
                } else {
                  peg$currPos = s5;
                  s5 = peg$FAILED;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            }
            s5 = peg$parseOWS();
            if (input.charCodeAt(peg$currPos) === 93) {
              s6 = peg$c13;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              {
                peg$fail(peg$e13);
              }
            }
            if (s6 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f20(s3, s4);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parsePrimitive() {
        var s0;
        s0 = peg$parseString();
        if (s0 === peg$FAILED) {
          s0 = peg$parseNumber();
          if (s0 === peg$FAILED) {
            s0 = peg$parseBoolean();
            if (s0 === peg$FAILED) {
              s0 = peg$parseNull();
            }
          }
        }
        return s0;
      }
      function peg$parseString() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$parseSQUOTE();
        if (s1 !== peg$FAILED) {
          s2 = [];
          s3 = peg$parseSquoteInString();
          if (s3 === peg$FAILED) {
            s3 = peg$parseStringNoSquote();
          }
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseSquoteInString();
            if (s3 === peg$FAILED) {
              s3 = peg$parseStringNoSquote();
            }
          }
          s3 = peg$parseSQUOTE();
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f21(s2);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseSquoteInString() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parseSQUOTE();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseSQUOTE();
          if (s2 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f22();
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseStringNoSquote() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = [];
        if (peg$r0.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          {
            peg$fail(peg$e14);
          }
        }
        if (s2 !== peg$FAILED) {
          while (s2 !== peg$FAILED) {
            s1.push(s2);
            if (peg$r0.test(input.charAt(peg$currPos))) {
              s2 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
              {
                peg$fail(peg$e14);
              }
            }
          }
        } else {
          s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f23();
        }
        s0 = s1;
        return s0;
      }
      function peg$parseNumber() {
        var s0, s2, s3, s4, s5, s6, s7, s8;
        s0 = peg$currPos;
        peg$parseSIGN();
        s2 = [];
        s3 = peg$parseDIGIT();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseDIGIT();
          }
        } else {
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 46) {
            s4 = peg$c14;
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            {
              peg$fail(peg$e15);
            }
          }
          if (s4 !== peg$FAILED) {
            s5 = [];
            s6 = peg$parseDIGIT();
            if (s6 !== peg$FAILED) {
              while (s6 !== peg$FAILED) {
                s5.push(s6);
                s6 = peg$parseDIGIT();
              }
            } else {
              s5 = peg$FAILED;
            }
            if (s5 !== peg$FAILED) {
              s4 = [s4, s5];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
          if (s3 === peg$FAILED) {
            s3 = null;
          }
          s4 = peg$currPos;
          if (input.substr(peg$currPos, 1).toLowerCase() === peg$c15) {
            s5 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            {
              peg$fail(peg$e16);
            }
          }
          if (s5 !== peg$FAILED) {
            s6 = peg$parseSIGN();
            if (s6 === peg$FAILED) {
              s6 = null;
            }
            s7 = [];
            s8 = peg$parseDIGIT();
            if (s8 !== peg$FAILED) {
              while (s8 !== peg$FAILED) {
                s7.push(s8);
                s8 = peg$parseDIGIT();
              }
            } else {
              s7 = peg$FAILED;
            }
            if (s7 !== peg$FAILED) {
              s5 = [s5, s6, s7];
              s4 = s5;
            } else {
              peg$currPos = s4;
              s4 = peg$FAILED;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$FAILED;
          }
          if (s4 === peg$FAILED) {
            s4 = null;
          }
          peg$savedPos = s0;
          s0 = peg$f24();
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      function peg$parseBoolean() {
        var s0, s1;
        s0 = peg$currPos;
        if (input.substr(peg$currPos, 4).toLowerCase() === peg$c16) {
          s1 = input.substr(peg$currPos, 4);
          peg$currPos += 4;
        } else {
          s1 = peg$FAILED;
          {
            peg$fail(peg$e17);
          }
        }
        if (s1 === peg$FAILED) {
          if (input.substr(peg$currPos, 5).toLowerCase() === peg$c17) {
            s1 = input.substr(peg$currPos, 5);
            peg$currPos += 5;
          } else {
            s1 = peg$FAILED;
            {
              peg$fail(peg$e18);
            }
          }
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f25(s1);
        }
        s0 = s1;
        return s0;
      }
      function peg$parseNull() {
        var s0, s1;
        s0 = peg$currPos;
        if (input.substr(peg$currPos, 4) === peg$c18) {
          s1 = peg$c18;
          peg$currPos += 4;
        } else {
          s1 = peg$FAILED;
          {
            peg$fail(peg$e19);
          }
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f26();
        }
        s0 = s1;
        return s0;
      }
      function peg$parseDirection() {
        var s0;
        if (input.substr(peg$currPos, 3) === peg$c19) {
          s0 = peg$c19;
          peg$currPos += 3;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e20);
          }
        }
        if (s0 === peg$FAILED) {
          if (input.substr(peg$currPos, 4) === peg$c20) {
            s0 = peg$c20;
            peg$currPos += 4;
          } else {
            s0 = peg$FAILED;
            {
              peg$fail(peg$e21);
            }
          }
        }
        return s0;
      }
      function peg$parseOdataIdentifier() {
        var s0, s1, s2, s3, s4;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseIdentifierLeadingCharacter();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseIdentifierCharacter();
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$parseIdentifierCharacter();
          }
          s2 = [s2, s3];
          s1 = s2;
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
          s0 = input.substring(s0, peg$currPos);
        } else {
          s0 = s1;
        }
        return s0;
      }
      function peg$parseIdentifierLeadingCharacter() {
        var s0;
        s0 = peg$parseALPHA();
        if (s0 === peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 95) {
            s0 = peg$c21;
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            {
              peg$fail(peg$e22);
            }
          }
        }
        return s0;
      }
      function peg$parseIdentifierCharacter() {
        var s0;
        s0 = peg$parseALPHA();
        if (s0 === peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 95) {
            s0 = peg$c21;
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            {
              peg$fail(peg$e22);
            }
          }
          if (s0 === peg$FAILED) {
            s0 = peg$parseDIGIT();
          }
        }
        return s0;
      }
      function peg$parseSIGN() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 43) {
          s0 = peg$c22;
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e23);
          }
        }
        if (s0 === peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 45) {
            s0 = peg$c23;
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            {
              peg$fail(peg$e24);
            }
          }
        }
        return s0;
      }
      function peg$parseALPHA() {
        var s0;
        if (peg$r1.test(input.charAt(peg$currPos))) {
          s0 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e25);
          }
        }
        if (s0 === peg$FAILED) {
          if (peg$r2.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            {
              peg$fail(peg$e26);
            }
          }
        }
        return s0;
      }
      function peg$parseDIGIT() {
        var s0;
        if (peg$r3.test(input.charAt(peg$currPos))) {
          s0 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e27);
          }
        }
        return s0;
      }
      function peg$parseSQUOTE() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 39) {
          s0 = peg$c24;
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e28);
          }
        }
        return s0;
      }
      function peg$parseSP() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 32) {
          s0 = peg$c25;
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          {
            peg$fail(peg$e29);
          }
        }
        return s0;
      }
      function peg$parseOWS() {
        var s0, s1;
        s0 = [];
        s1 = peg$parseSP();
        while (s1 !== peg$FAILED) {
          s0.push(s1);
          s1 = peg$parseSP();
        }
        return s0;
      }
      function peg$parseRWS() {
        var s0, s1;
        s0 = [];
        s1 = peg$parseSP();
        if (s1 !== peg$FAILED) {
          while (s1 !== peg$FAILED) {
            s0.push(s1);
            s1 = peg$parseSP();
          }
        } else {
          s0 = peg$FAILED;
        }
        return s0;
      }
      peg$result = peg$startRuleFunction();
      if (peg$result !== peg$FAILED && peg$currPos === input.length) {
        return peg$result;
      } else {
        if (peg$result !== peg$FAILED && peg$currPos < input.length) {
          peg$fail(peg$endExpectation());
        }
        throw peg$buildStructuredError(
          // @ts-ignore
          peg$maxFailExpected,
          // @ts-ignore
          peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null,
          // @ts-ignore
          peg$maxFailPos < input.length ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1) : peg$computeLocation(peg$maxFailPos, peg$maxFailPos)
        );
      }
    }
    return {
      SyntaxError: peg$SyntaxError,
      parse: peg$parse
    };
  }()
);
peggyParser.SyntaxError.prototype.name = "PeggySyntaxError";
const parse = peggyParser.parse;

var OrderByDirection = /* @__PURE__ */ ((OrderByDirection2) => {
  OrderByDirection2["ASC"] = "asc";
  OrderByDirection2["DESC"] = "desc";
  return OrderByDirection2;
})(OrderByDirection || {});
const parseFilter = (query) => {
  return parse$1(query);
};
const parseOrderBy = (query) => {
  return parse(query);
};

export { OrderByDirection, parseFilter, parseOrderBy };
